
#if !defined(AFX_LTREE_H__37F6C124_EFA7_11D4_A835_00500446BEC4__INCLUDED_)
#define AFX_LTREE_H__37F6C124_EFA7_11D4_A835_00500446BEC4__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "LVector.h"
#include "TransMatrix.h"

#define DRAW_COLOR RGB(141, 105, 20)
#define MAX_LEVEL 5

class LTree  
{
public:
	LTree(HDC hDc, int maxXY, int maxYZ, int maxXZ, double scaleFac, int cntL, int cntLev);
	virtual ~LTree();

	virtual void GenerateTree(LVector transPt, LVector vec, int level);
	virtual void DrawTransVector(LVector startPt, LVector vec);
	virtual TransMatrix GetXYRotationMatrix(double angle);
	virtual TransMatrix GetXZRotationMatrix(double angle);
	virtual TransMatrix GetYZRotationMatrix(double angle);

public:
	HDC m_hDc;
	HPEN m_hPen;
	HBRUSH m_hBrush;

	//parameters into computing
	//for each parameter pays that if it is zero it will be randomly generated
	int maxXYAngle;
	int maxXZAngle;
	int maxYZAngle;
	double scaleFactor;
	int cntLimbs;
	int cntLevels;
};

#endif 
