// MainDlg.cpp: implementation of the MainDlg class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "MainDlg.h"
#include "LTree.h"
#include "resource.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

MainDlg::MainDlg()
{

}

MainDlg::~MainDlg()
{

}


LRESULT MainDlg::onGenerateTree(WORD, WORD, HWND, BOOL & bHandled)
{
	char tmp[20];
	int maxXYAngle;
	int maxXZAngle;
	int maxYZAngle;
	double scaleFactor;
	int FX;
	int FY;
	int FZ;
	int SX;
	int SY;
	int SZ;
	int cntLimbs;
	int cntLevels;

	::GetWindowText(::GetDlgItem(*this, IDC_XYANGLE),tmp, 100); 
	maxXYAngle = atoi(tmp);

	::GetWindowText(::GetDlgItem(*this, IDC_XZANGLE),tmp, 100); 
	maxXZAngle = atoi(tmp);

	::GetWindowText(::GetDlgItem(*this, IDC_YZANGLE),tmp, 100); 
	maxYZAngle = atoi(tmp);

 	::GetWindowText(::GetDlgItem(*this, IDC_SCALEFACTOR),tmp, 100);
	scaleFactor = atof(tmp);

	::GetWindowText(::GetDlgItem(*this, IDC_LIMBSCNT),tmp, 100); 
	cntLimbs = atoi(tmp);

	::GetWindowText(::GetDlgItem(*this, IDC_STARTX),tmp, 100); 
	SX = atoi(tmp);

	::GetWindowText(::GetDlgItem(*this, IDC_STARTY),tmp, 100); 
	SY = atoi(tmp);

	::GetWindowText(::GetDlgItem(*this, IDC_STARTZ),tmp, 100); 
	SZ = atoi(tmp);

	::GetWindowText(::GetDlgItem(*this, IDC_FIRSTX),tmp, 100); 
	FX = atoi(tmp);

	::GetWindowText(::GetDlgItem(*this, IDC_FIRSTY),tmp, 100); 
	FY = atoi(tmp);

	::GetWindowText(::GetDlgItem(*this, IDC_FIRSTZ),tmp, 100); 
	FZ = atoi(tmp);

	::GetWindowText(::GetDlgItem(*this, IDC_LEVELS),tmp, 100); 
	cntLevels = atoi(tmp);

	ATLTRACE("MAINDLG: %d - %d - %d - %f - %d - %d - %d - %d - %d - %d - %d - %d\n", maxXYAngle, maxYZAngle, maxXZAngle, (double) scaleFactor, cntLimbs, SX, SY, SZ, FX, FY, FZ, cntLevels);
	m_wndTree.SetParameters(::GetDC(m_wndTree), maxXYAngle, maxYZAngle, maxXZAngle, scaleFactor, cntLimbs, SX, SY, SZ, FX, FY, FZ, cntLevels);
	::UpdateWindow(*this);
	m_wndTree.GenerateNewTree();
	ATLTRACE("--------\n");
	
	return(0);
}

LRESULT MainDlg::onExit(WORD, WORD, HWND, BOOL & bHandled)
{
	PostQuitMessage(0);
	return(0);
}

LRESULT MainDlg::onInitDialog(UINT xuInt, WPARAM xwParam, LPARAM xlParam, BOOL & bHandled)
{
	RECT rct = { 250, 10, 810, 680};

 	m_wndTree.Create(*this, rct, "L-System", WS_BORDER | WS_VISIBLE | WS_CHILDWINDOW);
 	::ShowWindow(*this, SW_SHOW);
	
	bHandled = FALSE;
	return(TRUE);
}

LRESULT MainDlg::onClose(UINT xuInt, WPARAM xwParam, LPARAM xlParam, BOOL & bHandled)
{
	PostQuitMessage(0);
	return(0);
}

LRESULT MainDlg::onDestroy(UINT xuInt, WPARAM xwParam, LPARAM xlParam, BOOL & bHandled)
{
	::DestroyWindow(*this);
	::DestroyWindow(m_wndTree);
	return(0);
}
