// MainWindow.cpp: implementation of the CMainWindow class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "MainWindow.h"
#include "LTree.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CMainWindow::CMainWindow()
{
}

CMainWindow::~CMainWindow()
{

}

void CMainWindow::SetParameters(HDC xhDc, int xmaxXY, int xmaxYZ, int xmaxXZ, double xscaleFac, int xcntL, int xSX, int xSY, int xSZ, int xFX, int xFY, int xFZ, int xcntLevels)
{
	hDc = xhDc;     
	maxXY = xmaxXY;   
	maxYZ = xmaxYZ;   
	maxXZ = xmaxXZ;   
	scaleFac = xscaleFac;
	cntL = xcntL;    
	SX = xSX;      
	SY = xSY;      
	SZ = xSZ;      
	FX = xFX;      
	FY = xFY;      
	FZ = xFZ;      
	levelCount = xcntLevels;
	ATLTRACE("co sme nasli: %d | %d | %d | %f | %d | %d | %d | %d | %d | %d | %d | %d\n", xmaxXY, xmaxYZ, xmaxXZ, xscaleFac, xcntL, xSX, xSY, xSZ, xFX, xFY, xFZ, xcntLevels);
	ATLTRACE("co sme setli: %d | %d | %d | %f | %d | %d | %d | %d | %d | %d | %d | %d\n", maxXY, maxYZ, maxXZ, scaleFac, cntL, SX, SY, SZ, FX, FY, FZ, levelCount);
}

void CMainWindow::GenerateNewTree()
{
	drawing = true;
	//::InvalidateRect(*this, NULL, TRUE);
	//::UpdateWindow(*this);

	HDC hDc = ::GetDC(*this);
	RECT rct = { 0, 0, 1000, 1000};
	FillRect(hDc, &rct, (HBRUSH) ::GetStockObject(WHITE_BRUSH));

	LVector pt(SX, SY, SZ);
	LVector vec(FX, FY, FZ);

	LTree m_lsysTree(hDc, maxXY, maxYZ, maxXZ, scaleFac, cntL, levelCount);

	m_lsysTree.DrawTransVector(pt, vec);
	m_lsysTree.GenerateTree(vec.Add(pt), vec, 0);
}

LRESULT CMainWindow::onDestroy(UINT xuInt, WPARAM xwParam, LPARAM xlParam, BOOL & bHandled)
{
	::DestroyWindow(*this);
	return(0);
}
