#include "stdafx.h"
#include "TransMatrix.h"

TransMatrix::TransMatrix()
{
	TransMatrix
	(	0,	0,	0,
		0,	0,	0,
		0,	0,	0
	);
}

TransMatrix::TransMatrix(double a11,	double a12,	double a13,
			double a21,	double a22,	double a23,
			double a31,	double a32,	double a33)
{
	e11 = a11;	e12 = a12;	e13 = a13;
	e21 = a21;	e22 = a22;	e23 = a23;
	e31 = a31;	e32 = a32;	e33 = a33;
}


TransMatrix::~TransMatrix()
{

}

TransMatrix TransMatrix::Multiply(TransMatrix m)
{
	TransMatrix res;

	res.e11 = this->e11*m.e11 + this->e12*m.e21 + this->e13*m.e31;
	res.e12 = this->e11*m.e12 + this->e12*m.e22 + this->e13*m.e32;
	res.e13 = this->e11*m.e13 + this->e12*m.e23 + this->e13*m.e33;

	res.e21 = this->e21*m.e11 + this->e22*m.e21 + this->e23*m.e31;
	res.e22 = this->e21*m.e12 + this->e22*m.e22 + this->e23*m.e32;
	res.e23 = this->e21*m.e13 + this->e22*m.e23 + this->e23*m.e33;

	res.e31 = this->e31*m.e11 + this->e32*m.e21 + this->e33*m.e31;
	res.e32 = this->e31*m.e12 + this->e32*m.e22 + this->e33*m.e32;
	res.e33 = this->e31*m.e13 + this->e32*m.e23 + this->e33*m.e33;

	return(res);
}

LVector TransMatrix::Multiply(LVector vec)
{
	LVector res;

	res.e1 = vec.e1*this->e11 + vec.e2*this->e21 + vec.e3*this->e31;
	res.e2 = vec.e1*this->e12 + vec.e2*this->e22 + vec.e3*this->e32;
	res.e3 = vec.e1*this->e13 + vec.e2*this->e23 + vec.e3*this->e33;

	return(res);
}

TransMatrix TransMatrix::Multiply(double scalar)
{
	TransMatrix res;

	res.e11 = this->e11*scalar;	res.e12 = this->e12*scalar;	res.e13 = this->e13*scalar;
	res.e21 = this->e21*scalar;	res.e22 = this->e22*scalar;	res.e23 = this->e23*scalar;
	res.e31 = this->e31*scalar;	res.e32 = this->e32*scalar;	res.e33 = this->e33*scalar;

	return(res);
}
